#include <stdio.h>
#include <stdlib.h>

int main()
{
    int T;
    scanf("%i", &T);
    
    int Ti[T];
    for(int i=0; i<T; i++) Ti[i]=0;
    
    for(int j=0; j<T; j++){
        int N;
        scanf("%i", &N);
        
        int a[N], b[N], a0, b0;
        for(int i=0; i<N; i++){
            scanf("%i", &a[i]);
            if(a[i]!=0) a0=i;}
        for(int i=0; i<N; i++){
            scanf("%i", &b[i]);
            if(b[i]!=0) b0=i;}
        
        if(abs(a0-b0)%2==0) Ti[j]=1;
    }
    for(int i=0; i<T; i++){
        if (Ti[i]==1) printf("DA\n");
        else printf("NE\n");}

    return 0;
}